
extern crate pest;
#[macro_use]
extern crate pest_derive;

use pest::Parser;
use std::fs;

#[derive(Parser)]
#[grammar = "csv.pest"]
pub struct CSVParser;

fn main() {
    let raw = fs::read_to_string("numbers.csv").expect("couldn't open file");
    let file = CSVParser::parse(Rule::file, &raw)
        .expect("syntax error")
        .next().unwrap();

    let mut sum: f64 = 0.0;
    let mut count: u64 = 0;

    for record in file.into_inner() {
        match record.as_rule() {
            Rule::record => {
                count += 1;
                for field in record.into_inner() {
                    sum += field.as_str().parse::<f64>().unwrap();
                }
            },
            Rule::EOI => (),
            _ => unreachable!(),
        }
    }

    println!("sum {} count {} avg (not implemented)", sum, count);
}
